
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int main(int argc, char *argv[]) {
	int pid;
	int stat;
	int p[2];
	int num;

	pipe(p);

	pid = fork();

	if( pid == 0 ) {
		// child
		close(p[1]);

		read(p[0], &num, sizeof(int));

		printf("child reports %d as parent id\n", num);

	} else {

		close(p[0]);

		num = getpid();

		write(p[1], &num, sizeof(int));

		wait(&stat);

		printf("parent %d exiting...\n", getpid());
	}

	return 0;
}
