
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int main(int argc, char *argv[]) {
	int i;
	int nb_proc = 0;
	int pid;


	if (argc != 2) {
		fprintf(stderr, "Usage: e1 nb\n");
		exit(-1);
	}

	nb_proc = atoi(argv[1]);

	for(i=1; i<nb_proc; i++) {

		pid = fork();

		if( pid == 0 ) {
			// child

			sleep(1);

			printf("child pid=%d\n", getpid());

			exit(0);
		}

	}

	for(i=1; i<nb_proc; i++) {
		int stat;
		wait(&stat);
	}

	printf("parent exiting...\n");

	return 0;
}
