
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int main(int argc, char *argv[]) {
	int pid;
	int stat;

	pid = fork();

	if( pid == 0 ) {
		// child
		if (execl("/bin/ls", "ls", "-l", NULL) == -1)
			perror("execl");
	}

	wait(&stat);

	printf("process with pid %d exiting...\n", getpid());

	return 0;
}
